<?
################################################################################
#    TGIOTT - The Guestbook Is On The Table - A simple configurable guestbook
#    Copyright (C) 2001 Rafael Ferreira Silva - rfsbsb@bol.com.br
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    See docs/license.txt to read the GPL licence
#
#################################################################################

ob_start();
session_start();

/*
   Including the necessary files
   
   Incluindo os arquivos necessários
*/
include("../lib/fasttemplate.php");
include("../lib/authentikate.php");
require("../lib/paging_class.php");
include("../config.php");
include("../lang/".$cfg["language"].".lang.php");
include("../common.inc.php");

/*
   Authing the user

   Autenticando o ousuário
*/
$auth = new AuthentiKate;
$auth->loginAuth('master','error.php','index.php');

/*
   Starting the template
   
   Iniciando o template
*/
$tpl = new FastTemplate('../template/'.$cfg["tpl_dir"]."/admin");
$tpl->define(array('edit'=>'edit.htm')); 


/*
   Starting the guestbook object and editing data

   Iniciando o objeto guestbook e editando os dados
*/
$gb = new guestbook;
$manage = new auxiliar;

if ($_POST["edit_var"]["submit"]){
   if ($manage->check_fields($_POST["edit_var"])){
      $gb->edit_data($_POST["edit_var"]);		
   }
   else{
      $tpl->assign('{ERROR}',$error);
   	  $tpl->assign('{EDIT_ID}',$_POST["edit_var"]["id"]);
	  $tpl->assign('{EDIT_NAME}',$_POST["edit_var"]["name"]);
	  $tpl->assign('{EDIT_EMAIL}',$_POST["edit_var"]["email"]);
   	  $tpl->assign('{EDIT_SITE}',$_POST["edit_var"]["site"]);
	  $tpl->assign('{EDIT_LOCATION}',$_POST["edit_var"]["location"]);
   	  $tpl->assign('{EDIT_COMMENT}',$_POST["edit_var"]["comment"]);
	  $tpl->assign('{EDIT_QUERY}',$_POST["edit_var"]["query"]);
   }
}
else{
   $fields = $gb->select_reg($_GET['id']);
   $tpl->assign('{ERROR}',$error);
   $tpl->assign('{EDIT_ID}',$fields["id"]);
   $tpl->assign('{EDIT_NAME}',$fields["name"]);
   $tpl->assign('{EDIT_EMAIL}',$fields["email"]);
   $tpl->assign('{EDIT_SITE}',$fields["site"]);
   $tpl->assign('{EDIT_LOCATION}',$fields["location"]);
   $tpl->assign('{EDIT_COMMENT}',$fields["comment"]);
   $tpl->assign('{EDIT_QUERY}',($_GET['page'] ? $_GET['page'] : 1));
}


/*
   General language parsing
   
   Substituição geral de idioma
*/
$tpl->assign('{BOOK_TITLE}',$book_title);
$tpl->assign('{TEMPLATE_DIR}',$cfg["tpl_dir"]);
$tpl->assign('{EDIT_PAGE_TITLE}',$lang['edit_page_title']);
$tpl->assign('{NAME_LABEL}',$lang['name_label']);
$tpl->assign('{LOCATION_LABEL}',$lang['location_label']);
$tpl->assign('{DATE_LABEL}',$lang['date_label']);
$tpl->assign('{COMMENT_LABEL}',$lang['comment_label']);
$tpl->assign('{HTTP_MESS}',$lang['http_mess']);
$tpl->assign('{MAX_CHARS}',$cfg['max_chars']);
$tpl->assign('{REMAIN_CHARS}',$lang['remain_chars']);
$tpl->assign('{EMAIL_LABEL}',$lang['email_label']);
$tpl->assign('{SITE_LABEL}',$lang['site_label']);
$tpl->assign('{EDIT_SUBMIT}',$lang['edit_submit']);

/*
   FastTemplate class content parsing

   Substituição do conteúdo através da classe FastTemplate
*/
$tpl->parse('OUTPUT','edit');
$tpl->FastPrint('OUTPUT');

ob_end_flush();
?>