<?
################################################################################
#    TGIOTT - The Guestbook Is On The Table - A simple configurable guestbook
#    Copyright (C) 2001 Rafael Ferreira Silva - rfsbsb@bol.com.br
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    See docs/license.txt to read the GPL licence
#
#################################################################################


/*
   Guestbook class declaration

   Declaração da classe do livro de visitas
*/
class guestbook{
   var $db;
   var $manage;
   
  
   /*
      Constructor method, it starts the database conecton

      Método construtor, ele inicia a conexão com o banco de dados
   */
   function guestbook($init_db=true,$fields=false){
      $this->manage = new auxiliar;
   
      if ($fields && $init_db){   
		 $this->db_conect($fields);
	  }
	  elseif ($init_db){
	     $this->db_conect($GLOBALS);
	  }
	  else {
	     return true;
      }
   }

   function db_conect ($db_vars) {
  
      $this->db = @mysql_connect($db_vars["db_host"], $db_vars["db_user"], $db_vars["db_pass"]) or
                   die($GLOBALS['lang']["db_connect_error_message"]);
      @mysql_select_db($db_vars["db_name"], $this->db);
   
   }

   /*
      Function to install the guestbook
   
      Função para instalar o livro
   */
   function install($fields){
      global $PHP_SELF;
	  //cleaning all fields
      $fields = $this->manage->strip_html_data($fields);
	  
	  //creating admin user authorization table
      $create_auth = @mysql_query("CREATE TABLE ".$fields["tbl_prefix"]."_auth (
                                            login varchar(20) NOT NULL default '',
                                            pwd varchar(255) NOT NULL default '',
                                            name varchar(75) NOT NULL default '',
                                            PRIMARY KEY  (login,pwd),
                                            UNIQUE KEY login (login),
                                            KEY login_2 (login,pwd)
                                            ) TYPE=MyISAM",$this->db);
											
	   //creating guestbook table itself
       $create_book = @mysql_query("CREATE TABLE ".$fields["tbl_prefix"]."_book (
                                            id int(10) NOT NULL auto_increment,
                                            name varchar(60) NOT NULL default '',
                                            location varchar(60) NOT NULL default '',
                                            email varchar(40) NOT NULL default '',
                                            site varchar(150) NOT NULL default '',
                                            comment text NOT NULL,
                                            date timestamp(14) NOT NULL,
                                            direct_aproval int(1) NOT NULL default '0',
                                            PRIMARY KEY  (id)
                                            ) TYPE=MyISAM",$this->db);
											
       //creating admin user privileges table
       $create_privs = @mysql_query("CREATE TABLE ".$fields["tbl_prefix"]."_privs (
                                            login varchar(20) NOT NULL default '',
                                            priv varchar(20) NOT NULL default '',
                                            KEY login (login,priv)
                                            ) TYPE=MyISAM",$this->db);

       //inserting admin user and permissions
       $insert_auth  = @mysql_query("INSERT INTO ".$fields["tbl_prefix"]."_auth VALUES 
	                                           ('".$fields['admin_user']."', '".md5($fields['admin_user_pass'])."', 
	                                           '".$fields['admin_user']."')",$this->db);
       $insert_privs = @mysql_query("INSERT INTO ".$fields["tbl_prefix"]."_privs VALUES 
	                                           ('".$fields['admin_user']."', 'master')",$this->db);

       //creating a variabel with the url to admin's page
       $explode = explode("/",$PHP_SELF);
	   $index = count($explode)-2;
	   $folder = $explode[$index];
	   $server = "http://".$_SERVER['SERVER_NAME']."/".$folder."/admin";
	   
	   //inserting a test data
       $insert_first_data = @mysql_query("INSERT INTO ".$fields["tbl_prefix"]."_book VALUES 
	                                    ('', 'Rafael Ferreira Silva', 'Brasília/DF/Brazil', 'rfsbsb@bol.com.br', 'http://www.webphp.com.br', 
										'<font color=\"#006600\">Parabéns, você instalou o TGIOTT com sucesso!</font>.\n\nEssa é uma mensagem de teste. Para remover/editar essa mensagem acesse ".$server." e conecte-se com seu usuário e senha..
										
										<font color=\"#FF0000\"><strong>Você deve remover o arquivo install.php do seu servidor.</strong></font>
										
										Obrigado por usar o TGIOTT',
										 NOW(), 1)",$this->db);
       $insert_first_data = @mysql_query("INSERT INTO ".$fields["tbl_prefix"]."_book VALUES 
	                                    ('', 'Rafael Ferreira Silva', 'Brasília/DF/Brazil', 'rfsbsb@bol.com.br', 'http://www.webphp.com.br', 
										'<font color=\"#006600\">Congratulations!! You have successfully instaled TGIOTT</font>.\n\nThis is the first entry to this copy of TGIOTT. To remove/edit this post, please access ".$server." and log in with your admin username and password.
										
										<font color=\"#FF0000\"><strong>You must delete the install.php file from your server.</strong></font>
										
										Thanks for use the TGIOTT', 
										 NOW(), 1)",$this->db);										 
      //sending the user to main page after install
      if ($create_auth && $create_book && $create_privs && $insert_auth && $insert_privs && $insert_first_data){
         return header("Location: index.php");
      }
  
   }



   /*
      Method to take all posted and authorized data. It organize the data in pages
     (the number of posts to page must be configured in config file)

      Método que traz todos os dados postdos e autorizados. Ele organiza os dados em páginas
      (o número de posts por página deve ser configurado no arquivo config)
   */
   function get_all_data($condition="direct_aproval=1"){
       //getting the object to construct navigation bar. require paging_class.php in lib directory
       global $paging;

       //using the paging library to print data by pages
       $paging->db($GLOBALS["db_host"], $GLOBALS["db_user"], $GLOBALS["db_pass"],$GLOBALS["db_name"]);
       $paging->query("SELECT *,UNIX_TIMESTAMP(date) AS date FROM ".$GLOBALS["tbl_prefix"]."_book WHERE $condition ORDER by id DESC");

       $i=0;
       //retreving data from db to return
       while($row = $paging->result_assoc()){
	      $list[$i]["id"]       = $row["id"];
          $list[$i]["name"]     = $this->manage->check_set_empty_field("name",$row["name"]);
          $list[$i]["email"]    = $this->manage->check_set_empty_field("email",$row["email"]);
          $list[$i]["site"]     = $this->manage->check_set_empty_field("site",$row["site"]);
          $list[$i]["location"] = $this->manage->check_set_empty_field("location",$row["location"]);
          $list[$i]["comment"]  = nl2br($row["comment"]);
          $list[$i]["date"]     = $this->manage->date_format($row["date"], $GLOBALS['lang']["date_format"]);
          $i++;
       }
       return $list;   
   }


   /*
      Function to select a specifc register
   
      Função para selecionar um registro especifico
   */
   function select_reg($id){
	  
      $result = @mysql_query("SELECT * FROM ".$GLOBALS["tbl_prefix"]."_book WHERE id='$id'",$this->db);
	  $list['id']       = @mysql_result($result,0,'id');
	  $list['name']     = @mysql_result($result,0,'name');
  	  $list['email']    = @mysql_result($result,0,'email');
	  $list['site']     = @mysql_result($result,0,'site');
	  $list['location'] = @mysql_result($result,0,'location');
	  $list['comment']  = @mysql_result($result,0,'comment');
      $list['date']     = @mysql_result($result,0,'date');
	  
	  return $list;

   }

   /*
      Function to export a CSV file
   
      Função para exportar o arquivo CSV
   */
   function export_csv(){
	  
	  $dumpfile = new iam_csvdump;
	  	  
      $query_string = "SELECT id,name,email,site,location, DATE_FORMAT(date,'".$GLOBALS['lang']["date_format"]."') AS date,comment FROM ".$GLOBALS["tbl_prefix"]."_book ORDER by id DESC";
	         
      $dumpfile->dump($query_string, "TGIOTT_data", "csv", $GLOBALS["db_name"], $GLOBALS["db_user"], $GLOBALS["db_pass"], $GLOBALS["db_host"]);	  
   }

   /*
      Function to add a comment in book
   
      Função para adicionar um novo comentário
   */
   function add_data($fields){
      
	  //cleaning all fields
      $fields = $this->manage->strip_html_data($fields);
	  
      $executed = @mysql_query("INSERT INTO ".$GLOBALS["tbl_prefix"]."_book 
                               VALUES ('', '$fields[name]', '$fields[location]', '$fields[email]',
                                       '$fields[site]','$fields[comment]',NOW(),'1')",$this->db);

      //sending the user to main page after add his comment
      if ($executed){
          return header("Location: index.php");
      }
   }


   /*
      Function to edit a comment in book
   
      Função para edit um comentário no livro
   */
   function edit_data($fields){
      
	  //cleaning all fields
      $fields = $this->manage->strip_html_data($fields);
	  
      $executed = @mysql_query("UPDATE ".$GLOBALS["tbl_prefix"]."_book SET
                               name='$fields[name]', location='$fields[location]', email='$fields[email]',
                               site='$fields[site]', comment='$fields[comment]', direct_aproval='1' 
							   WHERE id='$fields[id]'",$this->db);

      //sending the user to admin page after edit his comment
      if ($executed){
          return header("Location: admin.php?page=$fields[query]");
      } 
   }

   /*
      Function to edit a comment in book
   
      Função para edit um comentário no livro
   */
   function del_data($fields){      
	  
	  if ($fields['confirm'] == 1)  
         $executed = @mysql_query("DELETE FROM ".$GLOBALS["tbl_prefix"]."_book WHERE id='$fields[id]'",$this->db);
	  else
	     $executed = true;

      //sending the user to admin page after edit his comment
      if ($executed){
          return header("Location: admin.php?page=$fields[query]");
      }
   }   
} //end of guestbook class





/*
   Auxiliar class, used to help in manage the guestbook

   Classe auxiliar, usara para ajudar na gerência do livro de visitas
*/
class auxiliar {

   /*
      Function to test installation, check if dbname, dbuser, dbpass e dbhost are valid.
	  It also checks if there are a guestbook alerdy instaled.
   
      Função para testar a instalação, checa se dbname, dbuser, dbpass e dbhost são válidos
	  Também checa se já há um livro de visitas instalado.
   */
   function check_db_conection ($db_vars) {
      $ret_var = false;
      $db = @mysql_connect($db_vars["db_host"], $db_vars["db_user"], $db_vars["db_pass"]);	 
      if (!$db || !mysql_select_db($db_vars["db_name"], $db)) {
	     $this->set_db_error(mysql_errno());
	     return false;
	  }
	  
	  if (mysql_query("SELECT * FROM ".$db_vars["tbl_prefix"]."_book ",$db) ){
	     $this->set_db_error(10001);
	     return false;
	  }

       mysql_close($db);
	   return true;

   }

   /*
      Function to set human readable mysql errors   
      
	  Função para traduzir os erros de mysql para leitura humana.
   */
   function set_db_error($db_err_num) {

      switch ($db_err_num) {
	     case 10001:
		    return $GLOBALS["error"] = $GLOBALS["lang"]["db_error_alredy_instaled"];
		    break;
	     case 2005:
		    return $GLOBALS["error"] = $GLOBALS["lang"]["db_error_hostname"];
		    break;
		 case 1045:
		    return $GLOBALS["error"] = $GLOBALS["lang"]["db_error_user_or_pass"];
		    break;
		 case 1044:
		    return $GLOBALS["error"] = $GLOBALS["lang"]["db_error_database_name"];
		    break;
	  }   
   }


   /*
      Function to check data in installation and add forms

      Função para checar os dados nos formulários de inclusão e instalação
   */
   function check_fields($fields){
      foreach ($fields as $key => $val){
	      //checking empty data
          if ($GLOBALS["required_field"][$key] && empty($val)){
              $GLOBALS["error"] = $GLOBALS['lang']["add_error_empty_vars"];			  
              return false;			
          }
		  //checking email
          elseif ($GLOBALS["required_field"][$key] && $key == "email"){
		      //everything is ok
              if (!eregi("^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]{2,})+$", $val)){              
                  $GLOBALS["error"] = $GLOBALS['lang']["add_error_invalid_email"];                   
				   return false;
				 
              }
          }
		  //everything is ok
          else{
              continue;
          }
      }
      return true;
   }
   
   /*
      Function to clean up html from fields
   
      Função para limpara o html dos campos
   */
   function strip_html_data($fields,$allowed_tags = NULL){
   
       foreach($fields as $key => $val){
	      $fields_new[$key] = strip_tags($val,$allowed_tags);
       }
	   	   
       return $fields_new;
   }
   
  
   /*
      Date format method, format the date to a given format(in language file)

      Método para formatar data, formata a data para um fomato dado(no arquivo de idiomas)
   */
   function date_format($date,$format){
       return strftime($format,$date);
   }
   
   /*
      Check if empty and set an alternate value to empty fields

      Checa se está vazio e dá um valor alternativo para campos vazios
   */
   function check_set_empty_field($field,$value){
 
       if (empty($value))
	      return $GLOBALS["lang"]["empty_$field"];
	   else{
          if ($field == "site")
   	         $value = $this->addres_email_site($value,"site",$value);
	      if ($field == "email")
		     $value = $this->addres_email_site($value,"email",$value);
	    
	      return $value;
       }
   }
   
   /*
      Function to list a particular dir, getting its filenames
   
      Função para listar um diretório e pegar o nome dos seus arquivos
   */   
   function list_of_files ($dir){
      if (!empty($dir)) { 
         $handle = opendir($dir);
         $filename = array();
	     while (($file = readdir($handle)) !== false) {
	        if (($file != ".") && ($file != "..")) {
               $filename[] = $file;
            }
	     }	  
	     return $filename;
	  }
	  else
	     return array();
   }
   
   /*
      Function to get all languages avaible in language dir
   
      Funcção para pegar todos os idiomas disponíveis no diretório de idiomas
   */
   function get_languages(){
   
      $languages = array();
	  $files = $this->list_of_files('./lang/');
	  
	  foreach ($files as $file){
         $tmp = explode(".", $file);
		 $languages[] = $tmp[0];         
	  }
	  
	  return $languages;
   }
   
   /*
      Function to get all themes avaible in themes dir
   
      Funcção para pegar todos os tesmas disponíveis no diretório de temas
   */
   function get_template(){   
   	  return  $this->list_of_files('./template/');
   }

   /*
      Function to complements template system, determining the selection of a select box 
   
      Função para complementar o sistema de template, determinndo a seleção de um select box
   */
   function select_box_selected ($to_check,$value) {
      if ($to_check == $value) {
         $selected = "SELECTED";
      }
      else
         $selected = "";
		 
	  return $selected;
   }
   
   /*
      Function to complements template system, determining the selection of a check box 
   
      Função para complementar o sistema de template, determinndo a seleção de um check box
   */
   function check_box_selected ($to_check,$value) {
      if ($to_check == $value) {
         $selected = "CHECKED";
      }
      else
         $selected = " ";
		 
	  return $selected;
   }
   
   /*
      Function to parse e-mail and/or site
   
      Função para alterar e-mail e/ou site
   */
   function addres_email_site($value,$type,$name="") {
      
	  switch ($type) {
	  
	     case "email":
			return '<a href="mailto:'.$value.'">'.$name.'</a>';			   
            break;
		 case "site":
			return '<a href="http://'.$value.'">'.$name.'</a>';
		    break;
	  
	  }
   
   }
      
   
   /* 
      Determining the language to installation

      Determinando o idioma para a instalação   
   */
   function what_lang ($browser_lang) {
      $lang = substr($browser_lang,0,5);
      if (strtolower($lang) == "pt-br")	  
         $language = "pt_BR";
      else
         $language = "en_US";
		 
	  return $language;
   }
   
   /*
      Checking if we can write the config.php file in guestbook root dir.
   
      Checando se podemos gravar as informações no arquivo de configuração no diretório raiz do livro.
   */
   function check_write_config() {
      $filename = "./config.php";
      if (file_exists($filename))
	     if  (is_writable($filename))
		    return true;
         else{
		    $GLOBALS["error"] = $GLOBALS["lang"]["error_config_unwritable"];			
		 }
	  else{
         $GLOBALS["error"] = $GLOBALS["lang"]["error_config_dont_exists"];		  
	  }
   
   }
   
   /*
      Function to create the config file
	  
	  Função para criar o arquivo de configuração  
   */   
   function create_config ($vars) {

      $filename = "./config.php";
      $fp = fopen($filename, "w");
	  
	  $content = '<?
/*
   Documentation and license at docs dir

   Documentação e licença no diretório docs
*/
  
//db vars
$db_host          = "'.$vars["db_host"].'";
$db_user          = "'.$vars["db_user"].'";
$db_pass          = "'.$vars["db_pass"].'";
$db_name          = "'.$vars["db_name"].'";
$tbl_prefix       = "'.$vars["tbl_prefix"].'";

//required fields
$required_field["name"]     = "'.$vars["req_name"].'";
$required_field["email"]    = "'.$vars["req_email"].'";
$required_field["site"]     = "'.$vars["req_site"].'";
$required_field["location"] = "'.$vars["req_location"].'";

//other configurations variables
$cfg["language"]  = "'.$vars["language"].'";
$cfg["tpl_dir"]   = "'.$vars["template"].'";
$cfg["max_post_per_page"]   = '.$vars["max_posts"].';
$cfg["lists_in_navigation"] = '.$vars["list_navigation"].';
$cfg["max_chars"]          = '.$vars["max_chars"].';

?>';
	  
      if (fwrite($fp,$content,1024)){
	     return true;
	  }
	  else{
	     $GLOBALS["error"] = $GLOBALS["lang"]["error_cant_write_config"];
	  }
   }
   
}


?>