<?
################################################################################
#    TGIOTT - The Guestbook Is On The Table - A simple configurable guestbook
#    Copyright (C) 2001 Rafael Ferreira Silva - rfsbsb@bol.com.br
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#    See docs/license.txt to read the GPL licence
#
#################################################################################

ob_start();
/*
   Including the necessary files
   
   Incluindo os arquivos necessários
*/
include("lib/fasttemplate.php");
include("common.inc.php");

/*
   Creating the auxiliar class object

   Criando o objeto da classe auxiliar
*/
$manage = new auxiliar;

if (!$cfg["language"]){
   $cfg["language"] = $manage->what_lang($HTTP_ACCEPT_LANGUAGE);
}

include("lang/".$cfg["language"].".lang.php");


/*
   Starting the template
   
   Iniciando o template
*/
$cfg["tpl_dir"] = $cfg["tpl_dir"] ? $cfg["tpl_dir"] : "default";
$tpl = new FastTemplate('./template/'.$cfg["tpl_dir"]);
$tpl->define(array('install'=>'install.htm')); 
$tpl->no_strict();

/*
   Seting all fields as required

   Setando todos os campos como obrigatórios
*/
$required_field["db_host"]         = 1;
$required_field["db_user"]         = 1;
$required_field["db_pass"]         = 1;
$required_field["db_name"]         = 1;
$required_field["tbl_prefix"]      = 1;
$required_field["admin_user"]      = 1;
$required_field["admin_user_pass"] = 1;
$required_field["language"]        = 1;
$required_field["template"]        = 1;
$required_field["max_posts"]       = 1;
$required_field["list_navigation"] = 1;
$required_field["max_chars"]       = 1;


$manage->check_write_config();

/*
   Starting the guestbook 

   Iniciando o guestbook
*/
if ($_POST["install_var"]["submit"]){
   
   if ($manage->check_fields($_POST["install_var"]) && 
       $manage->check_db_conection($_POST["install_var"]) && 
	   $manage->check_write_config()
	   ){  
      $gb = new guestbook(true,$_POST["install_var"]);
	  $manage->create_config($_POST["install_var"]);
      $gb->install($_POST["install_var"]);		
   }
   else{
      $tpl->assign('{ERROR}',$error);
   	  $tpl->assign('{DB_HOST}',$_POST["install_var"]["db_host"]);
   	  $tpl->assign('{DB_USER}',$_POST["install_var"]["db_user"]);
   	  $tpl->assign('{DB_PASS}',$_POST["install_var"]["db_pass"]);
   	  $tpl->assign('{DB_NAME}',$_POST["install_var"]["db_name"]);
   	  $tpl->assign('{TBL_PREFIX}',$_POST["install_var"]["tbl_prefix"]);
   	  $tpl->assign('{ADMIN_USER}',$_POST["install_var"]["admin_user"]);
   	  $tpl->assign('{ADMIN_USER_PASS}',$_POST["install_var"]["admin_user_pass"]);
   	  $tpl->assign('{MAX_POSTS}',$_POST["install_var"]["max_posts"]);
   	  $tpl->assign('{LIST_NAVIGATION}',$_POST["install_var"]["list_navigation"]);
   	  $tpl->assign('{MAX_CHARS}',$_POST["install_var"]["max_chars"]);
	  $tpl->assign('{CHECK_NAME}',$manage->check_box_selected($_POST["install_var"]["req_name"],1) );
	  $tpl->assign('{CHECK_EMAIL}',$manage->check_box_selected($_POST["install_var"]["req_email"],1) );
	  $tpl->assign('{CHECK_SITE}',$manage->check_box_selected($_POST["install_var"]["req_site"],1) );
	  $tpl->assign('{CHECK_LOCATION}',$manage->check_box_selected($_POST["install_var"]["req_location"],1) );
	  
   }
}

/*
   Getting the avaible languages

   Pegando os idiomas disponíveis
*/
$tpl->define_dynamic("select_language","install");
$languages = $manage->get_languages();
for ($i=0;$i<count($languages);$i++) {
   $selected = $manage->select_box_selected($_POST["install_var"]["language"],$languages[$i]);
   $tpl->assign(array("{LANGUAGE_VALUES}" => $languages[$i],
                      "{LANGUAGE_SELECTED}" => $selected)); 
   $tpl->parse('LIST_LANG','.select_language');
}


/*
   Getting the avaible themes

   Pegando os idiomas themes
*/
$tpl->define_dynamic("select_template","install");
$template = $manage->get_template();
for ($i=0;$i<count($template);$i++) {
   $selected = $manage->select_box_selected($_POST["install_var"]["template"],$template[$i]);
   $tpl->assign(array("{TEMPLATE_VALUES}" => $template[$i],
                      "{TEMPLATE_SELECTED}" => $selected)); 
   $tpl->parse('LIST_TEMP','.select_template');
}   
   
   
   
/*
   General language parsing
   
   Substituição geral de idioma
*/
$tpl->assign('{TEMPLATE_DIR}',$cfg["tpl_dir"]);
$tpl->assign('{DB_HOST_LABEL}',$lang['db_host']);
$tpl->assign('{DB_USER_LABEL}',$lang['db_user']);
$tpl->assign('{DB_PASS_LABEL}',$lang['db_pass']);
$tpl->assign('{DB_PASSWORD_SHOW}',$lang['install_passowrd_show']);
$tpl->assign('{DB_NAME_LABEL}',$lang['db_name']);
$tpl->assign('{TBL_PREFIX_LABEL}',$lang['tbl_prefix']);
$tpl->assign('{ADMIN_USER_LABEL}',$lang['admin_user']);
$tpl->assign('{ADMIN_USER_PASS_LABEL}',$lang['admin_user_pass']);
$tpl->assign('{LANGUAGE_LABEL}',$lang['language']);
$tpl->assign('{TEMPLATE_LABEL}',$lang['template']);
$tpl->assign('{MAX_POSTS_LABEL}',$lang['max_posts']);
$tpl->assign('{LIST_NAVIGATION_LABEL}',$lang['list_navigation']);
$tpl->assign('{INSTALL_SUBMIT}',$lang['install_submit']);
$tpl->assign('{NAME_LABEL}',$lang['name_label']);
$tpl->assign('{LOCATION_LABEL}',$lang['location_label']);
$tpl->assign('{EMAIL_LABEL}',$lang['email_label']);
$tpl->assign('{SITE_LABEL}',$lang['site_label']);
$tpl->assign('{MAX_CHARS_LABEL}',$lang['max_chars_label']);
$tpl->assign('{REQUIRED_FIELDS_LABEL}',$lang['required_fields']);

$tpl->assign('{DB_HOST_INFO}',$lang['db_host_info']);
$tpl->assign('{DB_NAME_INFO}',$lang['db_name_info']);
$tpl->assign('{DB_USER_INFO}',$lang['db_user_info']);
$tpl->assign('{DB_TBL_PREFIX_INFO}',$lang['db_tbl_prefix_info']);
$tpl->assign('{ADMIN_USER_INFO}',$lang['admin_user_info']);
$tpl->assign('{LANGUAGE_INFO}',$lang['language_info']);
$tpl->assign('{TEMPLATE_INFO}',$lang['template_info']);
$tpl->assign('{MAX_POSTS_INFO}',$lang['max_posts_info']);
$tpl->assign('{LIST_NAVIGATION_INFO}',$lang['list_navigation_info']);
$tpl->assign('{MAX_CHARS_INFO}',$lang['max_chars_info']);
$tpl->assign('{REQUIRED_INFO}',$lang['required_info']);



/*
   FastTemplate class content parsing

   Substituição do conteúdo através da classe FastTemplate
*/
$tpl->parse('OUTPUT','install');
$tpl->FastPrint('OUTPUT');
ob_end_flush();
?>